install("FpM_invimage","GGG");
install("FpM_ker","GG");
fact(N)=
{
  b=ceil(log(N)/log(2));
  W=primes(3*b);
  W[1]=2;
  V=vecextract(W,concat("..",b));
  W=vecextract(W,concat(b+1,".."));
  M=matrix(b,2*b,i,j,kronecker(W[j],V[i])<0);
  Z=vectorv(b,i,kronecker(N,V[i])<0);
  R=FpM_invimage(M,Z,2);
  z=N/prod(i=1,#R,W[i]^R[i]);
  vector(b,i,sqrt(Mod(z,V[i])));
}
qfact(D,N)=
{
  local(P,V,M,Z,R);
  P=factor(abs(D))[,1];
  P=vector(#P,i,if(P[i]%4==3,-P[i],P[i]));
  V=[];
  forprime(p=2,100000,
    if(kronecker(D,p)==1,
      V=concat(V,p);
      if(#V>3*#P,break)));
  M=matrix(#P,#V,i,j,kronecker(P[i],V[j])<0);
  Z=vectorv(#P,i,kronecker(P[i],N)<0);
  R=FpM_invimage(M,Z,2);
  prod(i=1,#V,if(R[i],qfbprimeform(D,V[i]),1));
}
find(Q,A,B)=
{
  local(q,C2);
  C2=Q[3][1]^2;
  q=C2;
  for(i=1,Q[2][1]/2,
    if(i%1000==0,print1(i," "));
    if(q*A==B,return(i));
    q*=C2)
}
qfind(Q,A,N)=
{
  local(q,C2,V,g,l,N2,c=0);
  C2=Q[3][1]^2;
  q=C2*A;g=1;
  D=poldisc(C2);
  l=ceil(abs(D/4)^(1/4));
  for(i=1,Q[2][1]/2,
    if(i%1000==0,print1(i," "));
    V=Vec(q);
    g*=V[1];
    c++;
    if(c==10,
      c=0;
      g=gcd(g,N);
      if(g>1,return(g))
      );
    q=qfbnucomp(q,C2,l)
    );
  gcd(g,N);
}

bfind(Q,A,N)=
{
  local(q,C2,g,c=0);
  C2=Q[3][1]^2;
  q=C2*A;g=1;
  for(i=1,Q[2][1]/2,
    if(i%1000==0,print1(i," "));
    g*=lift(q);
    c++;
    if(c==10,
      c=0;
      g=gcd(g,N);
      if(g>1,return(g))
      );
    q*=C2;
    );
  gcd(g,N);
}

bfact(D,Q,N)=
{
  if(kronecker(D,N)!=1,error("bfact: (D|N)!=1"));
  qfind(Q,qfbred(qfact(D,N)),N)
}

binit(n)=D=-4*factorback(primes(n));Q=quadclassunit(D);

comp(n)=
{
  for(i=3,n,
   binit(i);
   B=sqrtint(-D)\4;
   print(i,":",B,":",log(Q[1]/2^(i-1))/log(B)))
}


test()=
{
  binit(17);
  N=nextprime(10^10)*nextprime(10^100)^2;
  bfact(D,Q,N)
}
